Subject: Re: Release management

From: Craig Sanders <[email-masked]>
Date: Mon, 1 Jul 1996 10:17:26 +1000 (EST)

On Tue, 25 Jun 1996, Scott Barker wrote:

> Ian Jackson said:
> > We *must* provide a tree which contains only the most rcently
> > bug-fixed versions of everything, and we *must not* require people to
> > download broken packages only to have to download good ones too.
> 
> ok. This is important, and I hadn't thought of it. But:

yeah. i can see both sides of this issue, and am still undecided as to
what i think is best. i tend towards agreeing with ian, mostly because
the debian version number is IMHO completely irrelevant - our version
differentiation is much more granular than that...it's the package
versions which matter, not the total distribution version.

however, i don't think it would be a good idea to change the way
things are currently done without a lot of promotion of the the ideas
behind dpkg.  I talk to a lot of people about debian, and most are
very happy with the improvement over their old slackware or redhat
system...BUT...they haven't yet figured out what dpkg allows them to do.

Debian is not just a different distribution, it's a different *type* of
distribution.  All other dists that i know of (with the single exception
of redhat) are monolithic beasts, with little or no control over the
individual software components.

The packaging system (and all the thought that went into it) is debian's
number 1 feature - it's even more important than the fact that debian
as a whole is well designed and all the parts are generally much better
integrated with each other than on other distributions.

As far as I am concerned, Debian is dpkg/dselect + base.  All other
packages are optional plug-in modules to add various types of
functionality to the base system...

this is not meant to put down the efforts of all the package developers
(including myself)...it's just an explanation of what i think is a good
way to look at what debian is.

> > There is no reason why we need to freeze the stuff in buzz, apart from
> > the `1.1 must mean 1.1' idea, which has no practical benefit.
> 
> It does for CD manufacturers and Consultants like myself:
> 
> Client: "I have a problem with my system."
> Me: "Which version of Debian do you have?"
> Client: "Debian 1.1"
> Me: "Yeah, but which version of Debian 1.1?"
> 
> What a headache. It would be better for them to be able to say:
> 
> Client: "I've got Debian 1.1, and I've upgraded the following packages..."

Client: I've got Debian 1.1, and I've upgraded the following packages...

You:    "debian 1.1" doesn't really tell me much.  Can you type:
            dpkg -l | mail -s "versions" [email-masked]

Client: OK.  done.

You:    aha.  i see you have foo-1.2-3.  Your problem was fixed in a later
        version.  You need to upgrade to 1.2-5.  I've attached a copy
        to this message, save it to a file and run 'dpkg -i' on it to
        upgrade.  You've also got old versions of the following packages
        <list>, which really should be upgraded.  You can get them from
        <ftpsite>.

If you're doing this sort of thing on several machines it shouldn't be
too hard to write a script to be run daily from cron which mails 'dpkg
-l' to a custom database program on your machine...then you will always
have an up-to-date summary of what is installed on all of your clients'
debian machines.

Craig